using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Categories;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IUserDistrictRepository
    {
        Task<BaseResult> Add(UserDistrictElastic UserDistrict);

        Task<BaseResult> AddManyAsync(IEnumerable<UserDistrictElastic> UserDistricts);

        Task<SmartTableResult<UserDistrictElastic>> Search(BoolQueryDescriptor<UserDistrictElastic> query);

        Task<SmartTableResult<UserDistrictElastic>> GetByIds(List<long> ids);

        Task<SmartTableResult<UserDistrictElastic>> GetAll();
    }

    public class UserDistrictRepository : IUserDistrictRepository
    {
        private readonly ElasticIndex<UserDistrictElastic> _dbContext;

        public UserDistrictRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<UserDistrictElastic>(settings.Value.ClusterUrl, "inventoryuserdistrict");
        }

        public async Task<SmartTableResult<UserDistrictElastic>> Search(BoolQueryDescriptor<UserDistrictElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(UserDistrictElastic UserDistrict)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(UserDistrict);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<UserDistrictElastic> UserDistricts)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(UserDistricts);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<UserDistrictElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<UserDistrictElastic>();
            var idsQ = new QueryContainerDescriptor<UserDistrictElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        public async Task<SmartTableResult<UserDistrictElastic>> GetAll()
        {
            var query = new BoolQueryDescriptor<UserDistrictElastic>();
            var isdeletedQ = new QueryContainerDescriptor<UserDistrictElastic>();
            isdeletedQ.Terms(t => t.Field(f => f.IsDeleted).Terms(false));
            query.Filter(f => isdeletedQ);
            return await _dbContext.Search(query);
        }
    }
}